Index: contrib/crossrpms/rtems4.9/m68k/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.9/m68k/Makefile.am	(revision 5b622a9dcb1377bd4a7ee9415853869b70e80a74)
+++ contrib/crossrpms/rtems4.9/m68k/Makefile.am	(revision 2c20b74574585c95e197967c850e7e8203b8821b)
@@ -13,5 +13,5 @@
 GCC_VERS = 4.3.1
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 13%{?dist}
+GCC_RPMREL = 14%{?dist}
 NEWLIB_VERS = 1.16.0
 include ../gcc.am
Index: contrib/crossrpms/rtems4.9/m68k/rtems-4.9-m68k-rtems4.9-binutils.spec
===================================================================
--- contrib/crossrpms/rtems4.9/m68k/rtems-4.9-m68k-rtems4.9-binutils.spec	(revision 5b622a9dcb1377bd4a7ee9415853869b70e80a74)
+++ contrib/crossrpms/rtems4.9/m68k/rtems-4.9-m68k-rtems4.9-binutils.spec	(revision 2c20b74574585c95e197967c850e7e8203b8821b)
@@ -12,4 +12,16 @@
 %else
 %define _exeext %{nil}
+%endif
+
+%ifos cygwin cygwin32
+%define optflags -O3 -pipe -march=i486 -funroll-loops
+%define _libdir			%{_exec_prefix}/lib
+%define debug_package		%{nil}
+%endif
+
+%if "%{_build}" != "%{_host}"
+%define _host_rpmprefix rtems-4.9-%{_host}-
+%else
+%define _host_rpmprefix %{nil}
 %endif
 
@@ -27,4 +39,6 @@
 BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
 
+BuildRequires:	%{_host_rpmprefix}gcc
+
 %if "%{binutils_version}" >= "2.18"
 # Bug in bfd: Doesn't build without texinfo installed
@@ -57,4 +71,5 @@
 
 %build
+  export PATH="%{_bindir}:${PATH}"
 %if "m68k-rtems4.9" == "i686-pc-cygwin"
 # The cygwin sources are leaking memory
@@ -63,4 +78,7 @@
   mkdir -p build
   cd build
+%if "%{_build}" != "%{_host}"
+  CFLAGS_FOR_BUILD="-g -O2 -Wall" \
+%endif
   CFLAGS="$RPM_OPT_FLAGS" \
   ../binutils-%{binutils_pkgvers}/configure \
@@ -81,4 +99,5 @@
 
 %install
+  export PATH="%{_bindir}:${PATH}"
   rm -rf $RPM_BUILD_ROOT
 
@@ -162,5 +181,4 @@
 
 %description -n rtems-4.9-m68k-rtems4.9-binutils
-
 GNU binutils targetting m68k-rtems4.9.
 
Index: contrib/crossrpms/rtems4.9/m68k/rtems-4.9-m68k-rtems4.9-cpukit.spec
===================================================================
--- contrib/crossrpms/rtems4.9/m68k/rtems-4.9-m68k-rtems4.9-cpukit.spec	(revision 5b622a9dcb1377bd4a7ee9415853869b70e80a74)
+++ contrib/crossrpms/rtems4.9/m68k/rtems-4.9-m68k-rtems4.9-cpukit.spec	(revision 2c20b74574585c95e197967c850e7e8203b8821b)
@@ -12,4 +12,16 @@
 %else
 %define _exeext %{nil}
+%endif
+
+%ifos cygwin cygwin32
+%define optflags -O3 -pipe -march=i486 -funroll-loops
+%define _libdir			%{_exec_prefix}/lib
+%define debug_package		%{nil}
+%endif
+
+%if "%{_build}" != "%{_host}"
+%define _host_rpmprefix rtems-4.9-%{_host}-
+%else
+%define _host_rpmprefix %{nil}
 %endif
 
Index: contrib/crossrpms/rtems4.9/m68k/rtems-4.9-m68k-rtems4.9-gcc.spec
===================================================================
--- contrib/crossrpms/rtems4.9/m68k/rtems-4.9-m68k-rtems4.9-gcc.spec	(revision 5b622a9dcb1377bd4a7ee9415853869b70e80a74)
+++ contrib/crossrpms/rtems4.9/m68k/rtems-4.9-m68k-rtems4.9-gcc.spec	(revision 2c20b74574585c95e197967c850e7e8203b8821b)
@@ -27,7 +27,7 @@
 
 
-%define gcc_pkgvers 4.3.0
-%define gcc_version 4.3.0
-%define gcc_rpmvers %{expand:%(echo "4.3.0" | tr - _ )}
+%define gcc_pkgvers 4.3.1
+%define gcc_version 4.3.1
+%define gcc_rpmvers %{expand:%(echo "4.3.1" | tr - _ )}
 
 %define newlib_version		1.16.0
@@ -41,5 +41,5 @@
 Group:	      	Development/Tools
 Version:        %{gcc_rpmvers}
-Release:      	12%{?dist}
+Release:      	14%{?dist}
 License:      	GPL
 URL:		http://gcc.gnu.org
@@ -56,5 +56,5 @@
 BuildRequires:  %{_host_rpmprefix}mpfr-devel
 %endif
-%if "%{?fedora}" >= "8"
+%if 0%{?fedora} >= 8
 BuildRequires:  mpfr-devel >= 2.3.0
 %endif
@@ -93,19 +93,19 @@
 %endif
 
+%if "%{gcc_version}" == "4.3.1"
+Source0:	ftp://ftp.gnu.org/pub/gnu/gcc/%{gcc_pkgvers}/gcc-core-%{gcc_pkgvers}.tar.bz2
+Patch0:		gcc-core-4.3.1-rtems4.9-20080609.diff
+%endif
 %if "%{gcc_version}" == "4.3.0"
 Source0:	ftp://ftp.gnu.org/pub/gnu/gcc/%{gcc_pkgvers}/gcc-core-%{gcc_pkgvers}.tar.bz2
-Patch0:		gcc-core-%{gcc_pkgvers}-rtems4.9-20080501.diff
-%endif
-%if "%{gcc_version}" == "4.2.3"
-Source0:	ftp://ftp.gnu.org/pub/gnu/gcc/%{gcc_pkgvers}/gcc-core-%{gcc_pkgvers}.tar.bz2
-Patch0:		gcc-core-4.2.3-rtems4.9-20080205.diff
+Patch0:		gcc-core-4.3.0-rtems4.9-20080501.diff
 %endif
 %{?_without_sources:NoSource:	0}
 
+%if "%{gcc_version}" == "4.3.1" 
+Source1:        ftp://ftp.gnu.org/pub/gnu/gcc/%{gcc_pkgvers}/gcc-g++-%{gcc_pkgvers}.tar.bz2
+%endif
 %if "%{gcc_version}" == "4.3.0" 
 Source1:        ftp://ftp.gnu.org/pub/gnu/gcc/%{gcc_pkgvers}/gcc-g++-%{gcc_pkgvers}.tar.bz2
-%endif
-%if  "%{gcc_version}" == "4.2.3"
-Source1: 	ftp://ftp.gnu.org/gnu/gcc/gcc-%{gcc_pkgvers}/gcc-g++-%{gcc_pkgvers}.tar.bz2
 %endif
 %{?_without_sources:NoSource:	1}
Index: contrib/crossrpms/rtems4.9/m68k/rtems-4.9-m68k-rtems4.9-gdb.spec
===================================================================
--- contrib/crossrpms/rtems4.9/m68k/rtems-4.9-m68k-rtems4.9-gdb.spec	(revision 5b622a9dcb1377bd4a7ee9415853869b70e80a74)
+++ contrib/crossrpms/rtems4.9/m68k/rtems-4.9-m68k-rtems4.9-gdb.spec	(revision 2c20b74574585c95e197967c850e7e8203b8821b)
@@ -105,6 +105,8 @@
     --disable-werror \
     --enable-sim \
+%if "%{gdb_version}" >= "6.7"
+    --with-system-readline \
+%endif
 %if "%{gdb_version}" >= "6.6"
-    --with-system-readline \
     --with-expat \
 %endif
